### Hierarchy

- IVisualizer

## Index

### Methods

- addFavoriteScene
- addProductToCart
- addProductToFavorites
- displayFavoriteProduct
- displayProduct
- displaySceneFromFavorites
- getApplicationsList
- getCurrentApplication
- getCurrentFilters
- getCurrentScene
- getCurrentSearchText
- getDisplayedProduct
- getDisplayedProducts
- getFavoriteProducts
- getFavoriteScenes
- getFilters
- getProductList
- getSceneList
- initAndLoad
- orderSample
- removeFavoriteScene
- removeProductFromFavorites
- setCurrentApplication
- setFavoriteProducts
- setFavoriteScenes
- setFilter
- setScene

## Methods

### Abstract addFavoriteScene

- addFavoriteScene(): Promise<IFavoriteSceneList>

- will add a scene to favorites will emit a "sceneAddedToFavorites" event

  #### Returns Promise<IFavoriteSceneList>

### Abstract addProductToCart

- addProductToCart(product: IProduct): void

- will emit a "productAddedToCart" event

  #### Parameters

  - ##### product: IProduct

  #### Returns void

### Abstract addProductToFavorites

- addProductToFavorites(product: IProduct): IFavoriteProductList

- will add a product to favorites will emit a "productAddedToFavorites" event

  #### Parameters

  - ##### product: IProduct

  #### Returns IFavoriteProductList

### Abstract displayFavoriteProduct

- displayFavoriteProduct(__namedParameters: { applications: string[]; sku: string }): Promise<void>

- will display product on each of the applications will emit a "productChanged" event after complete of each display

  #### Parameters

  - ##### __namedParameters: { applications: string[]; sku: string }

    - ##### applications: string[]

    - ##### sku: string

  #### Returns Promise<void>

### Abstract displayProduct

- displayProduct(productSku: string, _applications: IApplication | string[] | string, animateToProduct?: undefined | false | true): Promise<void>

- will set a product on a specific application will emit a "productChanged" event after complete

  #### Parameters

  - ##### productSku: string

  - ##### _applications: IApplication | string[] | string

  - ##### Optional animateToProduct: undefined | false | true

  #### Returns Promise<void>

### Abstract displaySceneFromFavorites

- displaySceneFromFavorites(setId: string): Promise<void>

- will display a saved scene will emit a "sceneDisplayed" event after complete

  #### Parameters

  - ##### setId: string

  #### Returns Promise<void>

### Abstract getApplicationsList

- getApplicationsList(): Array<IApplication> | undefined

- will return applications available on this experience

  #### Returns Array<IApplication> | undefined

### Abstract getCurrentApplication

- getCurrentApplication(): IApplication | undefined

- will return the current applications

  #### Returns IApplication | undefined

### Abstract getCurrentFilters

- getCurrentFilters(): Array<IConfigurationFilter>

- will return the current filters

  #### Returns Array<IConfigurationFilter>

### Abstract getCurrentScene

- getCurrentScene(): IScene

- will return the curren scene

  #### Returns IScene

### Abstract getCurrentSearchText

- getCurrentSearchText(): string

- will return the current filters

  #### Returns string

### Abstract getDisplayedProduct

- getDisplayedProduct(application: IApplication): IProduct | undefined

- will return the product displayed on an application in the current scene

  #### Parameters

  - ##### application: IApplication

  #### Returns IProduct | undefined

### Abstract getDisplayedProducts

- getDisplayedProducts(): Array<IProduct>

- will return all displayed products in the current scene

  #### Returns Array<IProduct>

### Abstract getFavoriteProducts

- getFavoriteProducts(): IFavoriteProductList

- will return the favorite products

  #### Returns IFavoriteProductList

### Abstract getFavoriteScenes

- getFavoriteScenes(): IFavoriteSceneList

- will return the favorite set list

  #### Returns IFavoriteSceneList

### Abstract getFilters

- getFilters(): Array<IConfigurationFilter>

- will return the available filters

  #### Returns Array<IConfigurationFilter>

### Abstract getProductList

- getProductList(): Array<IProduct> | undefined

- will return products list according to the current application and filters

  #### Returns Array<IProduct> | undefined

### Abstract getSceneList

- getSceneList(): Array<IScene>

- will return the scene list available in this experience

  #### Returns Array<IScene>

### Abstract initAndLoad

- initAndLoad(): Promise<void>

- start and load the visualizer app, will be triggered automatically on [data-role="visualizer"] elements after complete will emit a "visualizerLoaded" event

  #### Returns Promise<void>

### Abstract orderSample

- orderSample(product: IProduct): void

- will emit a "orderSample" event

  #### Parameters

  - ##### product: IProduct

  #### Returns void

### Abstract removeFavoriteScene

- removeFavoriteScene(setId: string): IFavoriteSceneList

- will remove a scene from favorites will emit a "sceneRemovedFromFavorites" event

  #### Parameters

  - ##### setId: string

  #### Returns IFavoriteSceneList

### Abstract removeProductFromFavorites

- removeProductFromFavorites(productSku: string, application: string): IFavoriteProductList

- will remove a product from favorites will emit a "productRemovedFromFavorites" event

  #### Parameters

  - ##### productSku: string

  - ##### application: string

  #### Returns IFavoriteProductList

### Abstract setCurrentApplication

- setCurrentApplication(param: { application: IApplication | string; enableRotate?: undefined | false | true; rotateOnlyWhenOutOfView?: undefined | false | true; rotateToCenterEvenIfnView?: undefined | false | true }): Promise<IApplication | undefined>

- will set the current applications

  #### Parameters

  - ##### param: { application: IApplication | string; enableRotate?: undefined | false | true; rotateOnlyWhenOutOfView?: undefined | false | true; rotateToCenterEvenIfnView?: undefined | false | true }

    - ##### application: IApplication | string

    - ##### Optional enableRotate?: undefined | false | true

    - ##### Optional rotateOnlyWhenOutOfView?: undefined | false | true

    - ##### Optional rotateToCenterEvenIfnView?: undefined | false | true

  #### Returns Promise<IApplication | undefined>

### Abstract setFavoriteProducts

- setFavoriteProducts(favoriteProducts: IFavoriteProductList | IFavoriteProductSkuAndApplicationList): void

- set favorite products Accepts array of favorite products that was sent previously by Visualizer or array of product skus and applications

  #### Parameters

  - ##### favoriteProducts: IFavoriteProductList | IFavoriteProductSkuAndApplicationList

  #### Returns void

### Abstract setFavoriteScenes

- setFavoriteScenes(favoriteScenes: IFavoriteSceneList): void

- set favorite scenes Accepts array of favorite scenes that was sent previously by Visualizer

  #### Parameters

  - ##### favoriteScenes: IFavoriteSceneList

  #### Returns void

### Abstract setFilter

- setFilter(filters: Array<IConfigurationFilter>): Array<IConfigurationFilter> | undefined

- will set the current filters

  #### Parameters

  - ##### filters: Array<IConfigurationFilter>

    the filters to set

  #### Returns Array<IConfigurationFilter> | undefined

### Abstract setScene

- setScene(param: { displayDefaultApplication?: undefined | false | true; preventDefaultProducts?: undefined | false | true; preventEvent?: undefined | false | true; sceneId?: undefined | string }): Promise<void>

- will set the current scene after complete will emit a "sceneLoaded" event

  #### Parameters

  - ##### param: { displayDefaultApplication?: undefined | false | true; preventDefaultProducts?: undefined | false | true; preventEvent?: undefined | false | true; sceneId?: undefined | string }

    - ##### Optional displayDefaultApplication?: undefined | false | true

    - ##### Optional preventDefaultProducts?: undefined | false | true

    - ##### Optional preventEvent?: undefined | false | true

    - ##### Optional sceneId?: undefined | string

  #### Returns Promise<void>

Generated using TypeDoc